<!--
 * @Description: 新增/编辑弹框
 * @Author: Sugar.
 * @Date: 2023-11-24 13:55:00
 * @LastEditors: gcz
 * @LastEditTime: 2024-03-05 14:17:50
 * @FilePath: \great_webui\src\views\device\PDAperson\dialog\addAndEdit.vue
 * @Copyright: Copyright (c) 2016~2023 by Sugar., All Rights Reserved.
-->
<template>
  <el-dialog
    :title="title"
    :visible.sync="open"
    width="700px"
    append-to-body
    :close-on-click-modal="false"
    @close="cancel"
  >
    <div class="dialog">
      <el-form :model="form" ref="form" :rules="rules" label-width="120px">
        <el-form-item label="工号" prop="jobNum" required>
          <el-input
            v-model="form.jobNum"
            placeholder="工号"
            clearable
            style="width: 100%;"
          />
        </el-form-item>
        <el-form-item label="姓名" prop="name">
          <el-input
            v-model="form.name"
            placeholder="姓名"
            clearable
            style="width: 100%;"
          />
        </el-form-item>
        <el-form-item label="联系电话" prop="mobile">
          <el-input
            v-model="form.mobile"
            placeholder="联系电话"
            clearable
            style="width: 100%;"
          />
        </el-form-item>
        <el-form-item label="性别" prop="sex">
          <el-select v-model="form.sex" placeholder="请选择性别">
                <el-option
                  v-for="dict in dict.type.sys_user_sex"
                  :key="dict.value"
                  :label="dict.label"
                  :value="Number(dict.value) "
                ></el-option>
              </el-select>
        </el-form-item>
        <el-form-item label="岗位" prop="postName">
          <el-input
            v-model="form.postName"
            placeholder="岗位"
            clearable
            style="width: 100%;"
          />
        </el-form-item>
        <el-form-item v-if="title == '添加人员'" label="密码" prop="password">
          <el-input
            v-model="form.password"
            placeholder="密码"
            clearable
            style="width: 100%;"
          />
        </el-form-item>

        
        
      </el-form>
    </div>
    <span slot="footer" class="dialog-footer">
      <el-button @click="cancel">取消</el-button>
      <el-button
        type="primary"
        @click="submitForm"
        v-loading.fullscreen.lock="loading"
        element-loading-text="提交中..."
        element-loading-spinner="el-icon-loading"
        element-loading-background="rgba(0, 0, 0, 0.8)"
      >
        <span v-if="loading">提交中...</span>
        <span v-else>保存</span>
      </el-button>
    </span>
  </el-dialog>
</template>

<script>
// import { updateNoticeMgr } from "@/api/system/noticeMgr";
import { saveAndEdit } from "@/api/PDAperson/PDAperson";
import { getToken } from "@/utils/auth";
// import { log } from 'mathjs';
export default {
  name: "addAndEdit",
  props: {
    dict: {
      type: Object,
      default: () => [],
    },
  },
  components: {
    
  },
  data() {
    return {
      title: "编辑",
      model: "EDIT",
      activeName: '01',
      open: false,
      loading: false,
      form: {
        id: undefined,
      },
      rules: {
        name: [{ required: true, message: "请输入姓名", trigger: ["change","blur"] }],
        jobNum: [{ required: true, message: "请输入工号", trigger: ["change","blur"] }],
        sex: [{ required: true, message: "请选择性别", trigger: ["change","blur"] }],
        mobile: [
          { required: true, message: "请输入联系电话", trigger: ["change","blur"] },
        ],
        postName	: [{ required: true, message: "请输入岗位", trigger: ["change","blur"] }],
        password: [{ required: true, message: "请输入密码", trigger: ["change","blur"] }],
      },
    };
  },
  methods: {
    /**
     * 打开弹框
     * @date 2023-11-22
     * @param {any} obj
     * @returns {any}
     */
    openDialog(title, obj) {
      this.open = true;
      this.reset();
      if (obj){
        this.title = "编辑人员";
        this.$nextTick(() => {
          this.$set(this.form, 'id', obj.id);
          this.$set(this.form, 'jobNum', obj.jobNum);
          this.$set(this.form, 'name', obj.name);
          this.$set(this.form, 'mobile', obj.mobile);
          this.$set(this.form, 'postName', obj.postName);
          this.$set(this.form, 'sex', obj.sex);
        });
      }else{
        this.title = "添加人员";
        this.$nextTick(() => {
          this.$refs["form"].clearValidate();
        });
      }
    },
    changePriceAmount(key) {
      if(this.form[key] * 1 < 0){
        this.$message.error("输入需大于或等于0!");
        this.$set(this.form, key, '');
        return false
      }
    },
    /**
     * 保存
     * @date 2023-11-22
     * @returns {any}
     */
    submitForm() {
      this.$refs["form"].validate(async (valid) => {
        if (valid) {
          try {
            this.loading = true;
            const { code } = await saveAndEdit({ ...this.form });
            if (code === 200) {
              this.$message.success("操作成功!");
              this.$emit("getList");
              this.cancel();
            }
          } catch (error) {
          } finally {
            this.loading = false;
          }
        }
      });
    },
    /**
     * 重置
     * @date 2023-11-22
     * @returns {any}
     */
    reset() {
      this.$set(this.form, 'id', '');
      this.$set(this.form, 'name', '');
      this.$set(this.form, 'jobNum', '');
      this.$set(this.form, 'mobile', '');
      this.$set(this.form, 'postName', '');
      this.$set(this.form, 'sex', '');
    },
    /**
     * 关闭弹框
     * @date 2023-11-22
     * @returns {any}
     */
    cancel() {
      this.reset();
      this.open = false;
    },
    /**
     * 上传成功
     * @date 2023-11-22
     * @param {any} res
     * @returns {any}
     */
    handleAvatarSuccess(res) {
      if (res.code === 200) {
        // this.form.mainImg = res?.data?.url;
        this.$set(this.form, 'mainImg', res?.data?.url)
      }
    },
    /**
     * 上传文件之前之前
     * @date 2023-11-22
     * @param {any} file
     * @returns {any}
     */
    beforeAvatarUpload(file) {
      const isJPG = file.type === "image/jpeg" || "image/png";
      if (!isJPG) {
        this.$message.error("上传头像图片只能是jpg或png格式!");
      }
      return isJPG;
    },
  },
};
</script>

<style lang="scss" scoped>
.dialog {
  padding: 0 30px;
  max-height: 65vh;
  overflow-y: auto;
}
.dialog {
  padding: 0 30px;
  .upload-btn {
    width: 100px;
    height: 100px;
    background-color: #fbfdff;
    border: dashed 1px #c0ccda;
    border-radius: 5px;
    i {
      font-size: 30px;
      margin-top: 20px;
    }
    &-text {
      margin-top: -10px;
    }
  }
  .avatar {
    cursor: pointer;
  }
}
</style>
